#ifndef _H_282212CFC5F391D48B855BF29DB14935_BoundingBox_DCPS_H_
#define _H_282212CFC5F391D48B855BF29DB14935_BoundingBox_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BoundingBox_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BoundingBox_TypeSupportInterface;

            typedef BoundingBox_TypeSupportInterface * BoundingBox_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox_TypeSupportInterface> BoundingBox_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BoundingBox_TypeSupportInterface> BoundingBox_TypeSupportInterface_out;


            class BoundingBox_DataWriter;

            typedef BoundingBox_DataWriter * BoundingBox_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox_DataWriter> BoundingBox_DataWriter_var;
            typedef DDS_DCPSInterface_out < BoundingBox_DataWriter> BoundingBox_DataWriter_out;


            class BoundingBox_DataReader;

            typedef BoundingBox_DataReader * BoundingBox_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox_DataReader> BoundingBox_DataReader_var;
            typedef DDS_DCPSInterface_out < BoundingBox_DataReader> BoundingBox_DataReader_out;


            class BoundingBox_DataReaderView;

            typedef BoundingBox_DataReaderView * BoundingBox_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BoundingBox_DataReaderView> BoundingBox_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BoundingBox_DataReaderView> BoundingBox_DataReaderView_out;

            struct BoundingBox_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < BoundingBox_, struct BoundingBox_Seq_uniq_> BoundingBox_Seq;
            typedef DDS_DCPSSequence_var < BoundingBox_Seq> BoundingBox_Seq_var;
            typedef DDS_DCPSSequence_out < BoundingBox_Seq> BoundingBox_Seq_out;

            class  BoundingBox_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BoundingBox_TypeSupportInterface_ptr _ptr_type;
                typedef BoundingBox_TypeSupportInterface_var _var_type;

                static BoundingBox_TypeSupportInterface_ptr _duplicate (BoundingBox_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BoundingBox_TypeSupportInterface () {};
                ~BoundingBox_TypeSupportInterface () {};
            private:
                BoundingBox_TypeSupportInterface (const BoundingBox_TypeSupportInterface &);
                BoundingBox_TypeSupportInterface & operator = (const BoundingBox_TypeSupportInterface &);
            };

            class  BoundingBox_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BoundingBox_DataWriter_ptr _ptr_type;
                typedef BoundingBox_DataWriter_var _var_type;

                static BoundingBox_DataWriter_ptr _duplicate (BoundingBox_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BoundingBox_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BoundingBox_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BoundingBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BoundingBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BoundingBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BoundingBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BoundingBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BoundingBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BoundingBox_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BoundingBox_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BoundingBox_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox_& instance_data) = 0;

            protected:
                BoundingBox_DataWriter () {};
                ~BoundingBox_DataWriter () {};
            private:
                BoundingBox_DataWriter (const BoundingBox_DataWriter &);
                BoundingBox_DataWriter & operator = (const BoundingBox_DataWriter &);
            };

            class  BoundingBox_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BoundingBox_DataReader_ptr _ptr_type;
                typedef BoundingBox_DataReader_var _var_type;

                static BoundingBox_DataReader_ptr _duplicate (BoundingBox_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBox_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox_& instance) = 0;

            protected:
                BoundingBox_DataReader () {};
                ~BoundingBox_DataReader () {};
            private:
                BoundingBox_DataReader (const BoundingBox_DataReader &);
                BoundingBox_DataReader & operator = (const BoundingBox_DataReader &);
            };

            class  BoundingBox_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BoundingBox_DataReaderView_ptr _ptr_type;
                typedef BoundingBox_DataReaderView_var _var_type;

                static BoundingBox_DataReaderView_ptr _duplicate (BoundingBox_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BoundingBox_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BoundingBox_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BoundingBox_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BoundingBox_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BoundingBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BoundingBox_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BoundingBox_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BoundingBox_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BoundingBox_& instance) = 0;

            protected:
                BoundingBox_DataReaderView () {};
                ~BoundingBox_DataReaderView () {};
            private:
                BoundingBox_DataReaderView (const BoundingBox_DataReaderView &);
                BoundingBox_DataReaderView & operator = (const BoundingBox_DataReaderView &);
            };
        }

    }

}

#endif
