#ifndef _H_A6BFBFB6A273C8AFB327E429F62D2B19_DiagnosticHeader_DCPS_H_
#define _H_A6BFBFB6A273C8AFB327E429F62D2B19_DiagnosticHeader_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DiagnosticHeader_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DiagnosticHeader_TypeSupportInterface;

            typedef DiagnosticHeader_TypeSupportInterface * DiagnosticHeader_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DiagnosticHeader_TypeSupportInterface> DiagnosticHeader_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DiagnosticHeader_TypeSupportInterface> DiagnosticHeader_TypeSupportInterface_out;


            class DiagnosticHeader_DataWriter;

            typedef DiagnosticHeader_DataWriter * DiagnosticHeader_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DiagnosticHeader_DataWriter> DiagnosticHeader_DataWriter_var;
            typedef DDS_DCPSInterface_out < DiagnosticHeader_DataWriter> DiagnosticHeader_DataWriter_out;


            class DiagnosticHeader_DataReader;

            typedef DiagnosticHeader_DataReader * DiagnosticHeader_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DiagnosticHeader_DataReader> DiagnosticHeader_DataReader_var;
            typedef DDS_DCPSInterface_out < DiagnosticHeader_DataReader> DiagnosticHeader_DataReader_out;


            class DiagnosticHeader_DataReaderView;

            typedef DiagnosticHeader_DataReaderView * DiagnosticHeader_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DiagnosticHeader_DataReaderView> DiagnosticHeader_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DiagnosticHeader_DataReaderView> DiagnosticHeader_DataReaderView_out;

            struct DiagnosticHeader_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DiagnosticHeader_, struct DiagnosticHeader_Seq_uniq_> DiagnosticHeader_Seq;
            typedef DDS_DCPSSequence_var < DiagnosticHeader_Seq> DiagnosticHeader_Seq_var;
            typedef DDS_DCPSSequence_out < DiagnosticHeader_Seq> DiagnosticHeader_Seq_out;

            class  DiagnosticHeader_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DiagnosticHeader_TypeSupportInterface_ptr _ptr_type;
                typedef DiagnosticHeader_TypeSupportInterface_var _var_type;

                static DiagnosticHeader_TypeSupportInterface_ptr _duplicate (DiagnosticHeader_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DiagnosticHeader_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DiagnosticHeader_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DiagnosticHeader_TypeSupportInterface () {};
                ~DiagnosticHeader_TypeSupportInterface () {};
            private:
                DiagnosticHeader_TypeSupportInterface (const DiagnosticHeader_TypeSupportInterface &);
                DiagnosticHeader_TypeSupportInterface & operator = (const DiagnosticHeader_TypeSupportInterface &);
            };

            class  DiagnosticHeader_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DiagnosticHeader_DataWriter_ptr _ptr_type;
                typedef DiagnosticHeader_DataWriter_var _var_type;

                static DiagnosticHeader_DataWriter_ptr _duplicate (DiagnosticHeader_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DiagnosticHeader_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DiagnosticHeader_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DiagnosticHeader_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DiagnosticHeader_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DiagnosticHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DiagnosticHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DiagnosticHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DiagnosticHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DiagnosticHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DiagnosticHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DiagnosticHeader_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DiagnosticHeader_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DiagnosticHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DiagnosticHeader_& instance_data) = 0;

            protected:
                DiagnosticHeader_DataWriter () {};
                ~DiagnosticHeader_DataWriter () {};
            private:
                DiagnosticHeader_DataWriter (const DiagnosticHeader_DataWriter &);
                DiagnosticHeader_DataWriter & operator = (const DiagnosticHeader_DataWriter &);
            };

            class  DiagnosticHeader_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DiagnosticHeader_DataReader_ptr _ptr_type;
                typedef DiagnosticHeader_DataReader_var _var_type;

                static DiagnosticHeader_DataReader_ptr _duplicate (DiagnosticHeader_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DiagnosticHeader_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DiagnosticHeader_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DiagnosticHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DiagnosticHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DiagnosticHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DiagnosticHeader_& instance) = 0;

            protected:
                DiagnosticHeader_DataReader () {};
                ~DiagnosticHeader_DataReader () {};
            private:
                DiagnosticHeader_DataReader (const DiagnosticHeader_DataReader &);
                DiagnosticHeader_DataReader & operator = (const DiagnosticHeader_DataReader &);
            };

            class  DiagnosticHeader_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DiagnosticHeader_DataReaderView_ptr _ptr_type;
                typedef DiagnosticHeader_DataReaderView_var _var_type;

                static DiagnosticHeader_DataReaderView_ptr _duplicate (DiagnosticHeader_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DiagnosticHeader_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DiagnosticHeader_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DiagnosticHeader_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DiagnosticHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DiagnosticHeader_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DiagnosticHeader_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DiagnosticHeader_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DiagnosticHeader_& instance) = 0;

            protected:
                DiagnosticHeader_DataReaderView () {};
                ~DiagnosticHeader_DataReaderView () {};
            private:
                DiagnosticHeader_DataReaderView (const DiagnosticHeader_DataReaderView &);
                DiagnosticHeader_DataReaderView & operator = (const DiagnosticHeader_DataReaderView &);
            };
        }

    }

}

#endif
