#ifndef _H_B9F3BA9FF988CF3DF389B7929D3AE601_MapPrimitive_DCPS_H_
#define _H_B9F3BA9FF988CF3DF389B7929D3AE601_MapPrimitive_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MapPrimitive_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MapPrimitive_TypeSupportInterface;

            typedef MapPrimitive_TypeSupportInterface * MapPrimitive_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MapPrimitive_TypeSupportInterface> MapPrimitive_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MapPrimitive_TypeSupportInterface> MapPrimitive_TypeSupportInterface_out;


            class MapPrimitive_DataWriter;

            typedef MapPrimitive_DataWriter * MapPrimitive_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MapPrimitive_DataWriter> MapPrimitive_DataWriter_var;
            typedef DDS_DCPSInterface_out < MapPrimitive_DataWriter> MapPrimitive_DataWriter_out;


            class MapPrimitive_DataReader;

            typedef MapPrimitive_DataReader * MapPrimitive_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MapPrimitive_DataReader> MapPrimitive_DataReader_var;
            typedef DDS_DCPSInterface_out < MapPrimitive_DataReader> MapPrimitive_DataReader_out;


            class MapPrimitive_DataReaderView;

            typedef MapPrimitive_DataReaderView * MapPrimitive_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MapPrimitive_DataReaderView> MapPrimitive_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MapPrimitive_DataReaderView> MapPrimitive_DataReaderView_out;

            struct MapPrimitive_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MapPrimitive_, struct MapPrimitive_Seq_uniq_> MapPrimitive_Seq;
            typedef DDS_DCPSSequence_var < MapPrimitive_Seq> MapPrimitive_Seq_var;
            typedef DDS_DCPSSequence_out < MapPrimitive_Seq> MapPrimitive_Seq_out;

            class  MapPrimitive_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MapPrimitive_TypeSupportInterface_ptr _ptr_type;
                typedef MapPrimitive_TypeSupportInterface_var _var_type;

                static MapPrimitive_TypeSupportInterface_ptr _duplicate (MapPrimitive_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MapPrimitive_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MapPrimitive_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MapPrimitive_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MapPrimitive_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MapPrimitive_TypeSupportInterface () {};
                ~MapPrimitive_TypeSupportInterface () {};
            private:
                MapPrimitive_TypeSupportInterface (const MapPrimitive_TypeSupportInterface &);
                MapPrimitive_TypeSupportInterface & operator = (const MapPrimitive_TypeSupportInterface &);
            };

            class  MapPrimitive_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MapPrimitive_DataWriter_ptr _ptr_type;
                typedef MapPrimitive_DataWriter_var _var_type;

                static MapPrimitive_DataWriter_ptr _duplicate (MapPrimitive_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MapPrimitive_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MapPrimitive_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MapPrimitive_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MapPrimitive_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MapPrimitive_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MapPrimitive_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MapPrimitive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MapPrimitive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MapPrimitive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MapPrimitive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MapPrimitive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MapPrimitive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MapPrimitive_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MapPrimitive_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MapPrimitive_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MapPrimitive_& instance_data) = 0;

            protected:
                MapPrimitive_DataWriter () {};
                ~MapPrimitive_DataWriter () {};
            private:
                MapPrimitive_DataWriter (const MapPrimitive_DataWriter &);
                MapPrimitive_DataWriter & operator = (const MapPrimitive_DataWriter &);
            };

            class  MapPrimitive_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MapPrimitive_DataReader_ptr _ptr_type;
                typedef MapPrimitive_DataReader_var _var_type;

                static MapPrimitive_DataReader_ptr _duplicate (MapPrimitive_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MapPrimitive_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MapPrimitive_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MapPrimitive_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MapPrimitive_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MapPrimitive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MapPrimitive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MapPrimitive_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MapPrimitive_& instance) = 0;

            protected:
                MapPrimitive_DataReader () {};
                ~MapPrimitive_DataReader () {};
            private:
                MapPrimitive_DataReader (const MapPrimitive_DataReader &);
                MapPrimitive_DataReader & operator = (const MapPrimitive_DataReader &);
            };

            class  MapPrimitive_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MapPrimitive_DataReaderView_ptr _ptr_type;
                typedef MapPrimitive_DataReaderView_var _var_type;

                static MapPrimitive_DataReaderView_ptr _duplicate (MapPrimitive_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MapPrimitive_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MapPrimitive_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MapPrimitive_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MapPrimitive_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MapPrimitive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MapPrimitive_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MapPrimitive_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MapPrimitive_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MapPrimitive_& instance) = 0;

            protected:
                MapPrimitive_DataReaderView () {};
                ~MapPrimitive_DataReaderView () {};
            private:
                MapPrimitive_DataReaderView (const MapPrimitive_DataReaderView &);
                MapPrimitive_DataReaderView & operator = (const MapPrimitive_DataReaderView &);
            };
        }

    }

}

#endif
