#ifndef _H_BD45E5657772648753F010428488D47B_Route__H_
#define _H_BD45E5657772648753F010428488D47B_Route__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "autoware_auto_msgs/msg/dds_opensplice/TrajectoryPoint_.h"
#include "autoware_auto_msgs/msg/dds_opensplice/MapPrimitive_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Route_Constants
            {
                const ::DDS::ULong CAPACITY_ = 100U;

            }

            struct  Route_
            {
                struct _primitives__seq_uniq_{};
                typedef DDS_DCPSBVLSeq< ::autoware_auto_msgs::msg::dds_::MapPrimitive_, 100 > _primitives__seq;
                typedef DDS_DCPSSequence_var< _primitives__seq > _primitives__seq_var;
                typedef DDS_DCPSSequence_out< _primitives__seq > _primitives__seq_out;
                ::std_msgs::msg::dds_::Header_ header_;
                ::autoware_auto_msgs::msg::dds_::TrajectoryPoint_ start_point_;
                ::autoware_auto_msgs::msg::dds_::TrajectoryPoint_ goal_point_;
                _primitives__seq primitives_;
            };

            typedef DDS_DCPSStruct_var<Route_> Route__var;
            typedef DDS_DCPSStruct_out < Route_> Route__out;

        }

    }

}

#endif /* _H_BD45E5657772648753F010428488D47B_Route__H_ */
