#ifndef _H_81B0EC0C8AE62786FF1F9A19F7F6FEC8_VehicleControlCommand_DCPS_H_
#define _H_81B0EC0C8AE62786FF1F9A19F7F6FEC8_VehicleControlCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleControlCommand_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleControlCommand_TypeSupportInterface;

            typedef VehicleControlCommand_TypeSupportInterface * VehicleControlCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlCommand_TypeSupportInterface> VehicleControlCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleControlCommand_TypeSupportInterface> VehicleControlCommand_TypeSupportInterface_out;


            class VehicleControlCommand_DataWriter;

            typedef VehicleControlCommand_DataWriter * VehicleControlCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlCommand_DataWriter> VehicleControlCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleControlCommand_DataWriter> VehicleControlCommand_DataWriter_out;


            class VehicleControlCommand_DataReader;

            typedef VehicleControlCommand_DataReader * VehicleControlCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlCommand_DataReader> VehicleControlCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleControlCommand_DataReader> VehicleControlCommand_DataReader_out;


            class VehicleControlCommand_DataReaderView;

            typedef VehicleControlCommand_DataReaderView * VehicleControlCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleControlCommand_DataReaderView> VehicleControlCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleControlCommand_DataReaderView> VehicleControlCommand_DataReaderView_out;

            struct VehicleControlCommand_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleControlCommand_, struct VehicleControlCommand_Seq_uniq_> VehicleControlCommand_Seq;
            typedef DDS_DCPSSequence_var < VehicleControlCommand_Seq> VehicleControlCommand_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleControlCommand_Seq> VehicleControlCommand_Seq_out;

            class  VehicleControlCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleControlCommand_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleControlCommand_TypeSupportInterface_var _var_type;

                static VehicleControlCommand_TypeSupportInterface_ptr _duplicate (VehicleControlCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleControlCommand_TypeSupportInterface () {};
                ~VehicleControlCommand_TypeSupportInterface () {};
            private:
                VehicleControlCommand_TypeSupportInterface (const VehicleControlCommand_TypeSupportInterface &);
                VehicleControlCommand_TypeSupportInterface & operator = (const VehicleControlCommand_TypeSupportInterface &);
            };

            class  VehicleControlCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleControlCommand_DataWriter_ptr _ptr_type;
                typedef VehicleControlCommand_DataWriter_var _var_type;

                static VehicleControlCommand_DataWriter_ptr _duplicate (VehicleControlCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleControlCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleControlCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControlCommand_& instance_data) = 0;

            protected:
                VehicleControlCommand_DataWriter () {};
                ~VehicleControlCommand_DataWriter () {};
            private:
                VehicleControlCommand_DataWriter (const VehicleControlCommand_DataWriter &);
                VehicleControlCommand_DataWriter & operator = (const VehicleControlCommand_DataWriter &);
            };

            class  VehicleControlCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleControlCommand_DataReader_ptr _ptr_type;
                typedef VehicleControlCommand_DataReader_var _var_type;

                static VehicleControlCommand_DataReader_ptr _duplicate (VehicleControlCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControlCommand_& instance) = 0;

            protected:
                VehicleControlCommand_DataReader () {};
                ~VehicleControlCommand_DataReader () {};
            private:
                VehicleControlCommand_DataReader (const VehicleControlCommand_DataReader &);
                VehicleControlCommand_DataReader & operator = (const VehicleControlCommand_DataReader &);
            };

            class  VehicleControlCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleControlCommand_DataReaderView_ptr _ptr_type;
                typedef VehicleControlCommand_DataReaderView_var _var_type;

                static VehicleControlCommand_DataReaderView_ptr _duplicate (VehicleControlCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleControlCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleControlCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleControlCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleControlCommand_& instance) = 0;

            protected:
                VehicleControlCommand_DataReaderView () {};
                ~VehicleControlCommand_DataReaderView () {};
            private:
                VehicleControlCommand_DataReaderView (const VehicleControlCommand_DataReaderView &);
                VehicleControlCommand_DataReaderView & operator = (const VehicleControlCommand_DataReaderView &);
            };
        }

    }

}

#endif
