#ifndef _H_86FDB093B67ECB125ACBA2FC05FAAF6D_VehicleStateCommand_DCPS_H_
#define _H_86FDB093B67ECB125ACBA2FC05FAAF6D_VehicleStateCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleStateCommand_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleStateCommand_TypeSupportInterface;

            typedef VehicleStateCommand_TypeSupportInterface * VehicleStateCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateCommand_TypeSupportInterface> VehicleStateCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleStateCommand_TypeSupportInterface> VehicleStateCommand_TypeSupportInterface_out;


            class VehicleStateCommand_DataWriter;

            typedef VehicleStateCommand_DataWriter * VehicleStateCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateCommand_DataWriter> VehicleStateCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleStateCommand_DataWriter> VehicleStateCommand_DataWriter_out;


            class VehicleStateCommand_DataReader;

            typedef VehicleStateCommand_DataReader * VehicleStateCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateCommand_DataReader> VehicleStateCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleStateCommand_DataReader> VehicleStateCommand_DataReader_out;


            class VehicleStateCommand_DataReaderView;

            typedef VehicleStateCommand_DataReaderView * VehicleStateCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleStateCommand_DataReaderView> VehicleStateCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleStateCommand_DataReaderView> VehicleStateCommand_DataReaderView_out;

            struct VehicleStateCommand_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < VehicleStateCommand_, struct VehicleStateCommand_Seq_uniq_> VehicleStateCommand_Seq;
            typedef DDS_DCPSSequence_var < VehicleStateCommand_Seq> VehicleStateCommand_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleStateCommand_Seq> VehicleStateCommand_Seq_out;

            class  VehicleStateCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleStateCommand_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleStateCommand_TypeSupportInterface_var _var_type;

                static VehicleStateCommand_TypeSupportInterface_ptr _duplicate (VehicleStateCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleStateCommand_TypeSupportInterface () {};
                ~VehicleStateCommand_TypeSupportInterface () {};
            private:
                VehicleStateCommand_TypeSupportInterface (const VehicleStateCommand_TypeSupportInterface &);
                VehicleStateCommand_TypeSupportInterface & operator = (const VehicleStateCommand_TypeSupportInterface &);
            };

            class  VehicleStateCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleStateCommand_DataWriter_ptr _ptr_type;
                typedef VehicleStateCommand_DataWriter_var _var_type;

                static VehicleStateCommand_DataWriter_ptr _duplicate (VehicleStateCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleStateCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleStateCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleStateCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleStateCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleStateCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleStateCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleStateCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleStateCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleStateCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleStateCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleStateCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateCommand_& instance_data) = 0;

            protected:
                VehicleStateCommand_DataWriter () {};
                ~VehicleStateCommand_DataWriter () {};
            private:
                VehicleStateCommand_DataWriter (const VehicleStateCommand_DataWriter &);
                VehicleStateCommand_DataWriter & operator = (const VehicleStateCommand_DataWriter &);
            };

            class  VehicleStateCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleStateCommand_DataReader_ptr _ptr_type;
                typedef VehicleStateCommand_DataReader_var _var_type;

                static VehicleStateCommand_DataReader_ptr _duplicate (VehicleStateCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateCommand_& instance) = 0;

            protected:
                VehicleStateCommand_DataReader () {};
                ~VehicleStateCommand_DataReader () {};
            private:
                VehicleStateCommand_DataReader (const VehicleStateCommand_DataReader &);
                VehicleStateCommand_DataReader & operator = (const VehicleStateCommand_DataReader &);
            };

            class  VehicleStateCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleStateCommand_DataReaderView_ptr _ptr_type;
                typedef VehicleStateCommand_DataReaderView_var _var_type;

                static VehicleStateCommand_DataReaderView_ptr _duplicate (VehicleStateCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleStateCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleStateCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleStateCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleStateCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleStateCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleStateCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleStateCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleStateCommand_& instance) = 0;

            protected:
                VehicleStateCommand_DataReaderView () {};
                ~VehicleStateCommand_DataReaderView () {};
            private:
                VehicleStateCommand_DataReaderView (const VehicleStateCommand_DataReaderView &);
                VehicleStateCommand_DataReaderView & operator = (const VehicleStateCommand_DataReaderView &);
            };
        }

    }

}

#endif
