// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from autoware_auto_msgs:msg/Quaternion32.idl
// generated code does not contain a copyright notice

#ifndef AUTOWARE_AUTO_MSGS__MSG__QUATERNION32__STRUCT_HPP_
#define AUTOWARE_AUTO_MSGS__MSG__QUATERNION32__STRUCT_HPP_

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32)
  #if defined(ERROR)
    #undef ERROR
  #endif
  #if defined(NO_ERROR)
    #undef NO_ERROR
  #endif
#endif

#ifndef _WIN32
# define DEPRECATED__autoware_auto_msgs__msg__Quaternion32 __attribute__((deprecated))
#else
# define DEPRECATED__autoware_auto_msgs__msg__Quaternion32 __declspec(deprecated)
#endif

namespace autoware_auto_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Quaternion32_
{
  using Type = Quaternion32_<ContainerAllocator>;

  explicit Quaternion32_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
      this->w = 1.0f;
    } else if (rosidl_generator_cpp::MessageInitialization::ZERO == _init) {
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
      this->w = 0.0f;
    }
  }

  explicit Quaternion32_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::DEFAULTS_ONLY == _init)
    {
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
      this->w = 1.0f;
    } else if (rosidl_generator_cpp::MessageInitialization::ZERO == _init) {
      this->x = 0.0f;
      this->y = 0.0f;
      this->z = 0.0f;
      this->w = 0.0f;
    }
  }

  // field types and members
  using _x_type =
    float;
  _x_type x;
  using _y_type =
    float;
  _y_type y;
  using _z_type =
    float;
  _z_type z;
  using _w_type =
    float;
  _w_type w;

  // setters for named parameter idiom
  Type & set__x(
    const float & _arg)
  {
    this->x = _arg;
    return *this;
  }
  Type & set__y(
    const float & _arg)
  {
    this->y = _arg;
    return *this;
  }
  Type & set__z(
    const float & _arg)
  {
    this->z = _arg;
    return *this;
  }
  Type & set__w(
    const float & _arg)
  {
    this->w = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator> *;
  using ConstRawPtr =
    const autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__autoware_auto_msgs__msg__Quaternion32
    std::shared_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__autoware_auto_msgs__msg__Quaternion32
    std::shared_ptr<autoware_auto_msgs::msg::Quaternion32_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Quaternion32_ & other) const
  {
    if (this->x != other.x) {
      return false;
    }
    if (this->y != other.y) {
      return false;
    }
    if (this->z != other.z) {
      return false;
    }
    if (this->w != other.w) {
      return false;
    }
    return true;
  }
  bool operator!=(const Quaternion32_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Quaternion32_

// alias to use template instance with default allocator
using Quaternion32 =
  autoware_auto_msgs::msg::Quaternion32_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace autoware_auto_msgs

#endif  // AUTOWARE_AUTO_MSGS__MSG__QUATERNION32__STRUCT_HPP_
