#ifndef _H_FDAA95CD292D8D5149C6E732EAC8CC90_AutonomyModeChange__H_
#define _H_FDAA95CD292D8D5149C6E732EAC8CC90_AutonomyModeChange__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Empty_.h"


namespace autoware_auto_msgs
{
    namespace srv
    {
        namespace dds_
        {
            namespace AutonomyModeChange_Request_Constants
            {
                const ::DDS::Octet MODE_MANUAL_ = 0;

                const ::DDS::Octet MODE_AUTONOMOUS_ = 1;

            }

            struct  AutonomyModeChange_Request_
            {
                ::DDS::Octet mode_;
            };

            typedef DDS_DCPSStruct_var<AutonomyModeChange_Request_> AutonomyModeChange_Request__var;
            typedef AutonomyModeChange_Request_& AutonomyModeChange_Request__out;

            struct  AutonomyModeChange_Response_
            {
                ::std_msgs::msg::dds_::Empty_ empty_;
            };

            typedef DDS_DCPSStruct_var<AutonomyModeChange_Response_> AutonomyModeChange_Response__var;
            typedef AutonomyModeChange_Response_& AutonomyModeChange_Response__out;

            struct  Sample_AutonomyModeChange_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::autoware_auto_msgs::srv::dds_::AutonomyModeChange_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_AutonomyModeChange_Request_> Sample_AutonomyModeChange_Request__var;
            typedef Sample_AutonomyModeChange_Request_& Sample_AutonomyModeChange_Request__out;

            struct  Sample_AutonomyModeChange_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::autoware_auto_msgs::srv::dds_::AutonomyModeChange_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_AutonomyModeChange_Response_> Sample_AutonomyModeChange_Response__var;
            typedef Sample_AutonomyModeChange_Response_& Sample_AutonomyModeChange_Response__out;

        }

    }

}

#endif /* _H_FDAA95CD292D8D5149C6E732EAC8CC90_AutonomyModeChange__H_ */
