#ifndef _H_80CE6905A2EA94C4DDB77BE5AD54958C_HADMapBin_DCPS_H_
#define _H_80CE6905A2EA94C4DDB77BE5AD54958C_HADMapBin_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HADMapBin_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HADMapBin_TypeSupportInterface;

            typedef HADMapBin_TypeSupportInterface * HADMapBin_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HADMapBin_TypeSupportInterface> HADMapBin_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HADMapBin_TypeSupportInterface> HADMapBin_TypeSupportInterface_out;


            class HADMapBin_DataWriter;

            typedef HADMapBin_DataWriter * HADMapBin_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HADMapBin_DataWriter> HADMapBin_DataWriter_var;
            typedef DDS_DCPSInterface_out < HADMapBin_DataWriter> HADMapBin_DataWriter_out;


            class HADMapBin_DataReader;

            typedef HADMapBin_DataReader * HADMapBin_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HADMapBin_DataReader> HADMapBin_DataReader_var;
            typedef DDS_DCPSInterface_out < HADMapBin_DataReader> HADMapBin_DataReader_out;


            class HADMapBin_DataReaderView;

            typedef HADMapBin_DataReaderView * HADMapBin_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HADMapBin_DataReaderView> HADMapBin_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HADMapBin_DataReaderView> HADMapBin_DataReaderView_out;

            struct HADMapBin_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HADMapBin_, struct HADMapBin_Seq_uniq_> HADMapBin_Seq;
            typedef DDS_DCPSSequence_var < HADMapBin_Seq> HADMapBin_Seq_var;
            typedef DDS_DCPSSequence_out < HADMapBin_Seq> HADMapBin_Seq_out;

            class  HADMapBin_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HADMapBin_TypeSupportInterface_ptr _ptr_type;
                typedef HADMapBin_TypeSupportInterface_var _var_type;

                static HADMapBin_TypeSupportInterface_ptr _duplicate (HADMapBin_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapBin_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HADMapBin_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapBin_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapBin_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HADMapBin_TypeSupportInterface () {};
                ~HADMapBin_TypeSupportInterface () {};
            private:
                HADMapBin_TypeSupportInterface (const HADMapBin_TypeSupportInterface &);
                HADMapBin_TypeSupportInterface & operator = (const HADMapBin_TypeSupportInterface &);
            };

            class  HADMapBin_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HADMapBin_DataWriter_ptr _ptr_type;
                typedef HADMapBin_DataWriter_var _var_type;

                static HADMapBin_DataWriter_ptr _duplicate (HADMapBin_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapBin_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HADMapBin_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapBin_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapBin_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HADMapBin_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HADMapBin_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HADMapBin_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HADMapBin_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HADMapBin_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HADMapBin_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HADMapBin_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HADMapBin_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HADMapBin_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HADMapBin_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HADMapBin_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapBin_& instance_data) = 0;

            protected:
                HADMapBin_DataWriter () {};
                ~HADMapBin_DataWriter () {};
            private:
                HADMapBin_DataWriter (const HADMapBin_DataWriter &);
                HADMapBin_DataWriter & operator = (const HADMapBin_DataWriter &);
            };

            class  HADMapBin_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HADMapBin_DataReader_ptr _ptr_type;
                typedef HADMapBin_DataReader_var _var_type;

                static HADMapBin_DataReader_ptr _duplicate (HADMapBin_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapBin_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HADMapBin_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapBin_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapBin_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HADMapBin_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HADMapBin_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HADMapBin_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapBin_& instance) = 0;

            protected:
                HADMapBin_DataReader () {};
                ~HADMapBin_DataReader () {};
            private:
                HADMapBin_DataReader (const HADMapBin_DataReader &);
                HADMapBin_DataReader & operator = (const HADMapBin_DataReader &);
            };

            class  HADMapBin_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HADMapBin_DataReaderView_ptr _ptr_type;
                typedef HADMapBin_DataReaderView_var _var_type;

                static HADMapBin_DataReaderView_ptr _duplicate (HADMapBin_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapBin_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HADMapBin_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapBin_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapBin_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HADMapBin_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HADMapBin_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HADMapBin_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HADMapBin_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapBin_& instance) = 0;

            protected:
                HADMapBin_DataReaderView () {};
                ~HADMapBin_DataReaderView () {};
            private:
                HADMapBin_DataReaderView (const HADMapBin_DataReaderView &);
                HADMapBin_DataReaderView & operator = (const HADMapBin_DataReaderView &);
            };
        }

    }

}

#endif
