#ifndef _H_B5503C16A0AC98324483CF1E7E153C2C_PointClusters_DCPS_H_
#define _H_B5503C16A0AC98324483CF1E7E153C2C_PointClusters_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "PointClusters_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class PointClusters_TypeSupportInterface;

            typedef PointClusters_TypeSupportInterface * PointClusters_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < PointClusters_TypeSupportInterface> PointClusters_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < PointClusters_TypeSupportInterface> PointClusters_TypeSupportInterface_out;


            class PointClusters_DataWriter;

            typedef PointClusters_DataWriter * PointClusters_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < PointClusters_DataWriter> PointClusters_DataWriter_var;
            typedef DDS_DCPSInterface_out < PointClusters_DataWriter> PointClusters_DataWriter_out;


            class PointClusters_DataReader;

            typedef PointClusters_DataReader * PointClusters_DataReader_ptr;
            typedef DDS_DCPSInterface_var < PointClusters_DataReader> PointClusters_DataReader_var;
            typedef DDS_DCPSInterface_out < PointClusters_DataReader> PointClusters_DataReader_out;


            class PointClusters_DataReaderView;

            typedef PointClusters_DataReaderView * PointClusters_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < PointClusters_DataReaderView> PointClusters_DataReaderView_var;
            typedef DDS_DCPSInterface_out < PointClusters_DataReaderView> PointClusters_DataReaderView_out;

            struct PointClusters_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < PointClusters_, struct PointClusters_Seq_uniq_> PointClusters_Seq;
            typedef DDS_DCPSSequence_var < PointClusters_Seq> PointClusters_Seq_var;
            typedef DDS_DCPSSequence_out < PointClusters_Seq> PointClusters_Seq_out;

            class  PointClusters_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef PointClusters_TypeSupportInterface_ptr _ptr_type;
                typedef PointClusters_TypeSupportInterface_var _var_type;

                static PointClusters_TypeSupportInterface_ptr _duplicate (PointClusters_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointClusters_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static PointClusters_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointClusters_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                PointClusters_TypeSupportInterface_ptr _this () { return this; }


            protected:
                PointClusters_TypeSupportInterface () {};
                ~PointClusters_TypeSupportInterface () {};
            private:
                PointClusters_TypeSupportInterface (const PointClusters_TypeSupportInterface &);
                PointClusters_TypeSupportInterface & operator = (const PointClusters_TypeSupportInterface &);
            };

            class  PointClusters_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef PointClusters_DataWriter_ptr _ptr_type;
                typedef PointClusters_DataWriter_var _var_type;

                static PointClusters_DataWriter_ptr _duplicate (PointClusters_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointClusters_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static PointClusters_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointClusters_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                PointClusters_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const PointClusters_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const PointClusters_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const PointClusters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const PointClusters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const PointClusters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const PointClusters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const PointClusters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const PointClusters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const PointClusters_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const PointClusters_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (PointClusters_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointClusters_& instance_data) = 0;

            protected:
                PointClusters_DataWriter () {};
                ~PointClusters_DataWriter () {};
            private:
                PointClusters_DataWriter (const PointClusters_DataWriter &);
                PointClusters_DataWriter & operator = (const PointClusters_DataWriter &);
            };

            class  PointClusters_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef PointClusters_DataReader_ptr _ptr_type;
                typedef PointClusters_DataReader_var _var_type;

                static PointClusters_DataReader_ptr _duplicate (PointClusters_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointClusters_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static PointClusters_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointClusters_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                PointClusters_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointClusters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointClusters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointClusters_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointClusters_& instance) = 0;

            protected:
                PointClusters_DataReader () {};
                ~PointClusters_DataReader () {};
            private:
                PointClusters_DataReader (const PointClusters_DataReader &);
                PointClusters_DataReader & operator = (const PointClusters_DataReader &);
            };

            class  PointClusters_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef PointClusters_DataReaderView_ptr _ptr_type;
                typedef PointClusters_DataReaderView_var _var_type;

                static PointClusters_DataReaderView_ptr _duplicate (PointClusters_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static PointClusters_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static PointClusters_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static PointClusters_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                PointClusters_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (PointClusters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (PointClusters_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (PointClusters_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (PointClusters_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const PointClusters_& instance) = 0;

            protected:
                PointClusters_DataReaderView () {};
                ~PointClusters_DataReaderView () {};
            private:
                PointClusters_DataReaderView (const PointClusters_DataReaderView &);
                PointClusters_DataReaderView & operator = (const PointClusters_DataReaderView &);
            };
        }

    }

}

#endif
