#ifndef _H_25D998B8D7D365636D61A896F6F60311_RawControlCommand_DCPS_H_
#define _H_25D998B8D7D365636D61A896F6F60311_RawControlCommand_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "RawControlCommand_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class RawControlCommand_TypeSupportInterface;

            typedef RawControlCommand_TypeSupportInterface * RawControlCommand_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < RawControlCommand_TypeSupportInterface> RawControlCommand_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < RawControlCommand_TypeSupportInterface> RawControlCommand_TypeSupportInterface_out;


            class RawControlCommand_DataWriter;

            typedef RawControlCommand_DataWriter * RawControlCommand_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < RawControlCommand_DataWriter> RawControlCommand_DataWriter_var;
            typedef DDS_DCPSInterface_out < RawControlCommand_DataWriter> RawControlCommand_DataWriter_out;


            class RawControlCommand_DataReader;

            typedef RawControlCommand_DataReader * RawControlCommand_DataReader_ptr;
            typedef DDS_DCPSInterface_var < RawControlCommand_DataReader> RawControlCommand_DataReader_var;
            typedef DDS_DCPSInterface_out < RawControlCommand_DataReader> RawControlCommand_DataReader_out;


            class RawControlCommand_DataReaderView;

            typedef RawControlCommand_DataReaderView * RawControlCommand_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < RawControlCommand_DataReaderView> RawControlCommand_DataReaderView_var;
            typedef DDS_DCPSInterface_out < RawControlCommand_DataReaderView> RawControlCommand_DataReaderView_out;

            struct RawControlCommand_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < RawControlCommand_, struct RawControlCommand_Seq_uniq_> RawControlCommand_Seq;
            typedef DDS_DCPSSequence_var < RawControlCommand_Seq> RawControlCommand_Seq_var;
            typedef DDS_DCPSSequence_out < RawControlCommand_Seq> RawControlCommand_Seq_out;

            class  RawControlCommand_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef RawControlCommand_TypeSupportInterface_ptr _ptr_type;
                typedef RawControlCommand_TypeSupportInterface_var _var_type;

                static RawControlCommand_TypeSupportInterface_ptr _duplicate (RawControlCommand_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RawControlCommand_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static RawControlCommand_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RawControlCommand_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                RawControlCommand_TypeSupportInterface_ptr _this () { return this; }


            protected:
                RawControlCommand_TypeSupportInterface () {};
                ~RawControlCommand_TypeSupportInterface () {};
            private:
                RawControlCommand_TypeSupportInterface (const RawControlCommand_TypeSupportInterface &);
                RawControlCommand_TypeSupportInterface & operator = (const RawControlCommand_TypeSupportInterface &);
            };

            class  RawControlCommand_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef RawControlCommand_DataWriter_ptr _ptr_type;
                typedef RawControlCommand_DataWriter_var _var_type;

                static RawControlCommand_DataWriter_ptr _duplicate (RawControlCommand_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RawControlCommand_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static RawControlCommand_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RawControlCommand_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                RawControlCommand_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const RawControlCommand_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const RawControlCommand_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const RawControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const RawControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const RawControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const RawControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const RawControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const RawControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const RawControlCommand_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const RawControlCommand_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (RawControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RawControlCommand_& instance_data) = 0;

            protected:
                RawControlCommand_DataWriter () {};
                ~RawControlCommand_DataWriter () {};
            private:
                RawControlCommand_DataWriter (const RawControlCommand_DataWriter &);
                RawControlCommand_DataWriter & operator = (const RawControlCommand_DataWriter &);
            };

            class  RawControlCommand_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef RawControlCommand_DataReader_ptr _ptr_type;
                typedef RawControlCommand_DataReader_var _var_type;

                static RawControlCommand_DataReader_ptr _duplicate (RawControlCommand_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RawControlCommand_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static RawControlCommand_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RawControlCommand_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                RawControlCommand_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RawControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RawControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RawControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RawControlCommand_& instance) = 0;

            protected:
                RawControlCommand_DataReader () {};
                ~RawControlCommand_DataReader () {};
            private:
                RawControlCommand_DataReader (const RawControlCommand_DataReader &);
                RawControlCommand_DataReader & operator = (const RawControlCommand_DataReader &);
            };

            class  RawControlCommand_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef RawControlCommand_DataReaderView_ptr _ptr_type;
                typedef RawControlCommand_DataReaderView_var _var_type;

                static RawControlCommand_DataReaderView_ptr _duplicate (RawControlCommand_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static RawControlCommand_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static RawControlCommand_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static RawControlCommand_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                RawControlCommand_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (RawControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (RawControlCommand_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (RawControlCommand_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (RawControlCommand_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const RawControlCommand_& instance) = 0;

            protected:
                RawControlCommand_DataReaderView () {};
                ~RawControlCommand_DataReaderView () {};
            private:
                RawControlCommand_DataReaderView (const RawControlCommand_DataReaderView &);
                RawControlCommand_DataReaderView & operator = (const RawControlCommand_DataReaderView &);
            };
        }

    }

}

#endif
