#ifndef _H_2162CAC00CF0C6AE2DB4938BC2A8E5CE_VehicleKinematicState_DCPS_H_
#define _H_2162CAC00CF0C6AE2DB4938BC2A8E5CE_VehicleKinematicState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "VehicleKinematicState_.h"


namespace autoware_auto_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class VehicleKinematicState_TypeSupportInterface;

            typedef VehicleKinematicState_TypeSupportInterface * VehicleKinematicState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < VehicleKinematicState_TypeSupportInterface> VehicleKinematicState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < VehicleKinematicState_TypeSupportInterface> VehicleKinematicState_TypeSupportInterface_out;


            class VehicleKinematicState_DataWriter;

            typedef VehicleKinematicState_DataWriter * VehicleKinematicState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < VehicleKinematicState_DataWriter> VehicleKinematicState_DataWriter_var;
            typedef DDS_DCPSInterface_out < VehicleKinematicState_DataWriter> VehicleKinematicState_DataWriter_out;


            class VehicleKinematicState_DataReader;

            typedef VehicleKinematicState_DataReader * VehicleKinematicState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < VehicleKinematicState_DataReader> VehicleKinematicState_DataReader_var;
            typedef DDS_DCPSInterface_out < VehicleKinematicState_DataReader> VehicleKinematicState_DataReader_out;


            class VehicleKinematicState_DataReaderView;

            typedef VehicleKinematicState_DataReaderView * VehicleKinematicState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < VehicleKinematicState_DataReaderView> VehicleKinematicState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < VehicleKinematicState_DataReaderView> VehicleKinematicState_DataReaderView_out;

            struct VehicleKinematicState_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < VehicleKinematicState_, struct VehicleKinematicState_Seq_uniq_> VehicleKinematicState_Seq;
            typedef DDS_DCPSSequence_var < VehicleKinematicState_Seq> VehicleKinematicState_Seq_var;
            typedef DDS_DCPSSequence_out < VehicleKinematicState_Seq> VehicleKinematicState_Seq_out;

            class  VehicleKinematicState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef VehicleKinematicState_TypeSupportInterface_ptr _ptr_type;
                typedef VehicleKinematicState_TypeSupportInterface_var _var_type;

                static VehicleKinematicState_TypeSupportInterface_ptr _duplicate (VehicleKinematicState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleKinematicState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleKinematicState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                VehicleKinematicState_TypeSupportInterface () {};
                ~VehicleKinematicState_TypeSupportInterface () {};
            private:
                VehicleKinematicState_TypeSupportInterface (const VehicleKinematicState_TypeSupportInterface &);
                VehicleKinematicState_TypeSupportInterface & operator = (const VehicleKinematicState_TypeSupportInterface &);
            };

            class  VehicleKinematicState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef VehicleKinematicState_DataWriter_ptr _ptr_type;
                typedef VehicleKinematicState_DataWriter_var _var_type;

                static VehicleKinematicState_DataWriter_ptr _duplicate (VehicleKinematicState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleKinematicState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleKinematicState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const VehicleKinematicState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const VehicleKinematicState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const VehicleKinematicState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const VehicleKinematicState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const VehicleKinematicState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const VehicleKinematicState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const VehicleKinematicState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const VehicleKinematicState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const VehicleKinematicState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const VehicleKinematicState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (VehicleKinematicState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleKinematicState_& instance_data) = 0;

            protected:
                VehicleKinematicState_DataWriter () {};
                ~VehicleKinematicState_DataWriter () {};
            private:
                VehicleKinematicState_DataWriter (const VehicleKinematicState_DataWriter &);
                VehicleKinematicState_DataWriter & operator = (const VehicleKinematicState_DataWriter &);
            };

            class  VehicleKinematicState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef VehicleKinematicState_DataReader_ptr _ptr_type;
                typedef VehicleKinematicState_DataReader_var _var_type;

                static VehicleKinematicState_DataReader_ptr _duplicate (VehicleKinematicState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleKinematicState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleKinematicState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleKinematicState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleKinematicState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleKinematicState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleKinematicState_& instance) = 0;

            protected:
                VehicleKinematicState_DataReader () {};
                ~VehicleKinematicState_DataReader () {};
            private:
                VehicleKinematicState_DataReader (const VehicleKinematicState_DataReader &);
                VehicleKinematicState_DataReader & operator = (const VehicleKinematicState_DataReader &);
            };

            class  VehicleKinematicState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef VehicleKinematicState_DataReaderView_ptr _ptr_type;
                typedef VehicleKinematicState_DataReaderView_var _var_type;

                static VehicleKinematicState_DataReaderView_ptr _duplicate (VehicleKinematicState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static VehicleKinematicState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static VehicleKinematicState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                VehicleKinematicState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (VehicleKinematicState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (VehicleKinematicState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (VehicleKinematicState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (VehicleKinematicState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const VehicleKinematicState_& instance) = 0;

            protected:
                VehicleKinematicState_DataReaderView () {};
                ~VehicleKinematicState_DataReaderView () {};
            private:
                VehicleKinematicState_DataReaderView (const VehicleKinematicState_DataReaderView &);
                VehicleKinematicState_DataReaderView & operator = (const VehicleKinematicState_DataReaderView &);
            };
        }

    }

}

#endif
