#ifndef _H_FDAA95CD292D8D5149C6E732EAC8CC90_AutonomyModeChange_DCPS_H_
#define _H_FDAA95CD292D8D5149C6E732EAC8CC90_AutonomyModeChange_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AutonomyModeChange_.h"


namespace autoware_auto_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class AutonomyModeChange_Request_TypeSupportInterface;

            typedef AutonomyModeChange_Request_TypeSupportInterface * AutonomyModeChange_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Request_TypeSupportInterface> AutonomyModeChange_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Request_TypeSupportInterface> AutonomyModeChange_Request_TypeSupportInterface_out;


            class AutonomyModeChange_Request_DataWriter;

            typedef AutonomyModeChange_Request_DataWriter * AutonomyModeChange_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Request_DataWriter> AutonomyModeChange_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Request_DataWriter> AutonomyModeChange_Request_DataWriter_out;


            class AutonomyModeChange_Request_DataReader;

            typedef AutonomyModeChange_Request_DataReader * AutonomyModeChange_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Request_DataReader> AutonomyModeChange_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Request_DataReader> AutonomyModeChange_Request_DataReader_out;


            class AutonomyModeChange_Request_DataReaderView;

            typedef AutonomyModeChange_Request_DataReaderView * AutonomyModeChange_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Request_DataReaderView> AutonomyModeChange_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Request_DataReaderView> AutonomyModeChange_Request_DataReaderView_out;

            struct AutonomyModeChange_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AutonomyModeChange_Request_, struct AutonomyModeChange_Request_Seq_uniq_> AutonomyModeChange_Request_Seq;
            typedef DDS_DCPSSequence_var < AutonomyModeChange_Request_Seq> AutonomyModeChange_Request_Seq_var;
            typedef DDS_DCPSSequence_out < AutonomyModeChange_Request_Seq> AutonomyModeChange_Request_Seq_out;

            class  AutonomyModeChange_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutonomyModeChange_Request_TypeSupportInterface_ptr _ptr_type;
                typedef AutonomyModeChange_Request_TypeSupportInterface_var _var_type;

                static AutonomyModeChange_Request_TypeSupportInterface_ptr _duplicate (AutonomyModeChange_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutonomyModeChange_Request_TypeSupportInterface () {};
                ~AutonomyModeChange_Request_TypeSupportInterface () {};
            private:
                AutonomyModeChange_Request_TypeSupportInterface (const AutonomyModeChange_Request_TypeSupportInterface &);
                AutonomyModeChange_Request_TypeSupportInterface & operator = (const AutonomyModeChange_Request_TypeSupportInterface &);
            };

            class  AutonomyModeChange_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutonomyModeChange_Request_DataWriter_ptr _ptr_type;
                typedef AutonomyModeChange_Request_DataWriter_var _var_type;

                static AutonomyModeChange_Request_DataWriter_ptr _duplicate (AutonomyModeChange_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutonomyModeChange_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutonomyModeChange_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutonomyModeChange_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutonomyModeChange_Request_& instance_data) = 0;

            protected:
                AutonomyModeChange_Request_DataWriter () {};
                ~AutonomyModeChange_Request_DataWriter () {};
            private:
                AutonomyModeChange_Request_DataWriter (const AutonomyModeChange_Request_DataWriter &);
                AutonomyModeChange_Request_DataWriter & operator = (const AutonomyModeChange_Request_DataWriter &);
            };

            class  AutonomyModeChange_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutonomyModeChange_Request_DataReader_ptr _ptr_type;
                typedef AutonomyModeChange_Request_DataReader_var _var_type;

                static AutonomyModeChange_Request_DataReader_ptr _duplicate (AutonomyModeChange_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutonomyModeChange_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutonomyModeChange_Request_& instance) = 0;

            protected:
                AutonomyModeChange_Request_DataReader () {};
                ~AutonomyModeChange_Request_DataReader () {};
            private:
                AutonomyModeChange_Request_DataReader (const AutonomyModeChange_Request_DataReader &);
                AutonomyModeChange_Request_DataReader & operator = (const AutonomyModeChange_Request_DataReader &);
            };

            class  AutonomyModeChange_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutonomyModeChange_Request_DataReaderView_ptr _ptr_type;
                typedef AutonomyModeChange_Request_DataReaderView_var _var_type;

                static AutonomyModeChange_Request_DataReaderView_ptr _duplicate (AutonomyModeChange_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutonomyModeChange_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutonomyModeChange_Request_& instance) = 0;

            protected:
                AutonomyModeChange_Request_DataReaderView () {};
                ~AutonomyModeChange_Request_DataReaderView () {};
            private:
                AutonomyModeChange_Request_DataReaderView (const AutonomyModeChange_Request_DataReaderView &);
                AutonomyModeChange_Request_DataReaderView & operator = (const AutonomyModeChange_Request_DataReaderView &);
            };
            class AutonomyModeChange_Response_TypeSupportInterface;

            typedef AutonomyModeChange_Response_TypeSupportInterface * AutonomyModeChange_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Response_TypeSupportInterface> AutonomyModeChange_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Response_TypeSupportInterface> AutonomyModeChange_Response_TypeSupportInterface_out;


            class AutonomyModeChange_Response_DataWriter;

            typedef AutonomyModeChange_Response_DataWriter * AutonomyModeChange_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Response_DataWriter> AutonomyModeChange_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Response_DataWriter> AutonomyModeChange_Response_DataWriter_out;


            class AutonomyModeChange_Response_DataReader;

            typedef AutonomyModeChange_Response_DataReader * AutonomyModeChange_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Response_DataReader> AutonomyModeChange_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Response_DataReader> AutonomyModeChange_Response_DataReader_out;


            class AutonomyModeChange_Response_DataReaderView;

            typedef AutonomyModeChange_Response_DataReaderView * AutonomyModeChange_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AutonomyModeChange_Response_DataReaderView> AutonomyModeChange_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AutonomyModeChange_Response_DataReaderView> AutonomyModeChange_Response_DataReaderView_out;

            struct AutonomyModeChange_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AutonomyModeChange_Response_, struct AutonomyModeChange_Response_Seq_uniq_> AutonomyModeChange_Response_Seq;
            typedef DDS_DCPSSequence_var < AutonomyModeChange_Response_Seq> AutonomyModeChange_Response_Seq_var;
            typedef DDS_DCPSSequence_out < AutonomyModeChange_Response_Seq> AutonomyModeChange_Response_Seq_out;

            class  AutonomyModeChange_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AutonomyModeChange_Response_TypeSupportInterface_ptr _ptr_type;
                typedef AutonomyModeChange_Response_TypeSupportInterface_var _var_type;

                static AutonomyModeChange_Response_TypeSupportInterface_ptr _duplicate (AutonomyModeChange_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AutonomyModeChange_Response_TypeSupportInterface () {};
                ~AutonomyModeChange_Response_TypeSupportInterface () {};
            private:
                AutonomyModeChange_Response_TypeSupportInterface (const AutonomyModeChange_Response_TypeSupportInterface &);
                AutonomyModeChange_Response_TypeSupportInterface & operator = (const AutonomyModeChange_Response_TypeSupportInterface &);
            };

            class  AutonomyModeChange_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AutonomyModeChange_Response_DataWriter_ptr _ptr_type;
                typedef AutonomyModeChange_Response_DataWriter_var _var_type;

                static AutonomyModeChange_Response_DataWriter_ptr _duplicate (AutonomyModeChange_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AutonomyModeChange_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AutonomyModeChange_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AutonomyModeChange_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutonomyModeChange_Response_& instance_data) = 0;

            protected:
                AutonomyModeChange_Response_DataWriter () {};
                ~AutonomyModeChange_Response_DataWriter () {};
            private:
                AutonomyModeChange_Response_DataWriter (const AutonomyModeChange_Response_DataWriter &);
                AutonomyModeChange_Response_DataWriter & operator = (const AutonomyModeChange_Response_DataWriter &);
            };

            class  AutonomyModeChange_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AutonomyModeChange_Response_DataReader_ptr _ptr_type;
                typedef AutonomyModeChange_Response_DataReader_var _var_type;

                static AutonomyModeChange_Response_DataReader_ptr _duplicate (AutonomyModeChange_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutonomyModeChange_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutonomyModeChange_Response_& instance) = 0;

            protected:
                AutonomyModeChange_Response_DataReader () {};
                ~AutonomyModeChange_Response_DataReader () {};
            private:
                AutonomyModeChange_Response_DataReader (const AutonomyModeChange_Response_DataReader &);
                AutonomyModeChange_Response_DataReader & operator = (const AutonomyModeChange_Response_DataReader &);
            };

            class  AutonomyModeChange_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AutonomyModeChange_Response_DataReaderView_ptr _ptr_type;
                typedef AutonomyModeChange_Response_DataReaderView_var _var_type;

                static AutonomyModeChange_Response_DataReaderView_ptr _duplicate (AutonomyModeChange_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AutonomyModeChange_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AutonomyModeChange_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AutonomyModeChange_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AutonomyModeChange_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AutonomyModeChange_Response_& instance) = 0;

            protected:
                AutonomyModeChange_Response_DataReaderView () {};
                ~AutonomyModeChange_Response_DataReaderView () {};
            private:
                AutonomyModeChange_Response_DataReaderView (const AutonomyModeChange_Response_DataReaderView &);
                AutonomyModeChange_Response_DataReaderView & operator = (const AutonomyModeChange_Response_DataReaderView &);
            };
            class Sample_AutonomyModeChange_Request_TypeSupportInterface;

            typedef Sample_AutonomyModeChange_Request_TypeSupportInterface * Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Request_TypeSupportInterface> Sample_AutonomyModeChange_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Request_TypeSupportInterface> Sample_AutonomyModeChange_Request_TypeSupportInterface_out;


            class Sample_AutonomyModeChange_Request_DataWriter;

            typedef Sample_AutonomyModeChange_Request_DataWriter * Sample_AutonomyModeChange_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Request_DataWriter> Sample_AutonomyModeChange_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Request_DataWriter> Sample_AutonomyModeChange_Request_DataWriter_out;


            class Sample_AutonomyModeChange_Request_DataReader;

            typedef Sample_AutonomyModeChange_Request_DataReader * Sample_AutonomyModeChange_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Request_DataReader> Sample_AutonomyModeChange_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Request_DataReader> Sample_AutonomyModeChange_Request_DataReader_out;


            class Sample_AutonomyModeChange_Request_DataReaderView;

            typedef Sample_AutonomyModeChange_Request_DataReaderView * Sample_AutonomyModeChange_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Request_DataReaderView> Sample_AutonomyModeChange_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Request_DataReaderView> Sample_AutonomyModeChange_Request_DataReaderView_out;

            struct Sample_AutonomyModeChange_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_AutonomyModeChange_Request_, struct Sample_AutonomyModeChange_Request_Seq_uniq_> Sample_AutonomyModeChange_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_AutonomyModeChange_Request_Seq> Sample_AutonomyModeChange_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AutonomyModeChange_Request_Seq> Sample_AutonomyModeChange_Request_Seq_out;

            class  Sample_AutonomyModeChange_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Request_TypeSupportInterface_var _var_type;

                static Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr _duplicate (Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AutonomyModeChange_Request_TypeSupportInterface () {};
                ~Sample_AutonomyModeChange_Request_TypeSupportInterface () {};
            private:
                Sample_AutonomyModeChange_Request_TypeSupportInterface (const Sample_AutonomyModeChange_Request_TypeSupportInterface &);
                Sample_AutonomyModeChange_Request_TypeSupportInterface & operator = (const Sample_AutonomyModeChange_Request_TypeSupportInterface &);
            };

            class  Sample_AutonomyModeChange_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AutonomyModeChange_Request_DataWriter_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Request_DataWriter_var _var_type;

                static Sample_AutonomyModeChange_Request_DataWriter_ptr _duplicate (Sample_AutonomyModeChange_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AutonomyModeChange_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AutonomyModeChange_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AutonomyModeChange_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AutonomyModeChange_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutonomyModeChange_Request_& instance_data) = 0;

            protected:
                Sample_AutonomyModeChange_Request_DataWriter () {};
                ~Sample_AutonomyModeChange_Request_DataWriter () {};
            private:
                Sample_AutonomyModeChange_Request_DataWriter (const Sample_AutonomyModeChange_Request_DataWriter &);
                Sample_AutonomyModeChange_Request_DataWriter & operator = (const Sample_AutonomyModeChange_Request_DataWriter &);
            };

            class  Sample_AutonomyModeChange_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AutonomyModeChange_Request_DataReader_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Request_DataReader_var _var_type;

                static Sample_AutonomyModeChange_Request_DataReader_ptr _duplicate (Sample_AutonomyModeChange_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutonomyModeChange_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutonomyModeChange_Request_& instance) = 0;

            protected:
                Sample_AutonomyModeChange_Request_DataReader () {};
                ~Sample_AutonomyModeChange_Request_DataReader () {};
            private:
                Sample_AutonomyModeChange_Request_DataReader (const Sample_AutonomyModeChange_Request_DataReader &);
                Sample_AutonomyModeChange_Request_DataReader & operator = (const Sample_AutonomyModeChange_Request_DataReader &);
            };

            class  Sample_AutonomyModeChange_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AutonomyModeChange_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Request_DataReaderView_var _var_type;

                static Sample_AutonomyModeChange_Request_DataReaderView_ptr _duplicate (Sample_AutonomyModeChange_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutonomyModeChange_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutonomyModeChange_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutonomyModeChange_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutonomyModeChange_Request_& instance) = 0;

            protected:
                Sample_AutonomyModeChange_Request_DataReaderView () {};
                ~Sample_AutonomyModeChange_Request_DataReaderView () {};
            private:
                Sample_AutonomyModeChange_Request_DataReaderView (const Sample_AutonomyModeChange_Request_DataReaderView &);
                Sample_AutonomyModeChange_Request_DataReaderView & operator = (const Sample_AutonomyModeChange_Request_DataReaderView &);
            };
            class Sample_AutonomyModeChange_Response_TypeSupportInterface;

            typedef Sample_AutonomyModeChange_Response_TypeSupportInterface * Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Response_TypeSupportInterface> Sample_AutonomyModeChange_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Response_TypeSupportInterface> Sample_AutonomyModeChange_Response_TypeSupportInterface_out;


            class Sample_AutonomyModeChange_Response_DataWriter;

            typedef Sample_AutonomyModeChange_Response_DataWriter * Sample_AutonomyModeChange_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Response_DataWriter> Sample_AutonomyModeChange_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Response_DataWriter> Sample_AutonomyModeChange_Response_DataWriter_out;


            class Sample_AutonomyModeChange_Response_DataReader;

            typedef Sample_AutonomyModeChange_Response_DataReader * Sample_AutonomyModeChange_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Response_DataReader> Sample_AutonomyModeChange_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Response_DataReader> Sample_AutonomyModeChange_Response_DataReader_out;


            class Sample_AutonomyModeChange_Response_DataReaderView;

            typedef Sample_AutonomyModeChange_Response_DataReaderView * Sample_AutonomyModeChange_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_AutonomyModeChange_Response_DataReaderView> Sample_AutonomyModeChange_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_AutonomyModeChange_Response_DataReaderView> Sample_AutonomyModeChange_Response_DataReaderView_out;

            struct Sample_AutonomyModeChange_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_AutonomyModeChange_Response_, struct Sample_AutonomyModeChange_Response_Seq_uniq_> Sample_AutonomyModeChange_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_AutonomyModeChange_Response_Seq> Sample_AutonomyModeChange_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_AutonomyModeChange_Response_Seq> Sample_AutonomyModeChange_Response_Seq_out;

            class  Sample_AutonomyModeChange_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Response_TypeSupportInterface_var _var_type;

                static Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr _duplicate (Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_AutonomyModeChange_Response_TypeSupportInterface () {};
                ~Sample_AutonomyModeChange_Response_TypeSupportInterface () {};
            private:
                Sample_AutonomyModeChange_Response_TypeSupportInterface (const Sample_AutonomyModeChange_Response_TypeSupportInterface &);
                Sample_AutonomyModeChange_Response_TypeSupportInterface & operator = (const Sample_AutonomyModeChange_Response_TypeSupportInterface &);
            };

            class  Sample_AutonomyModeChange_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_AutonomyModeChange_Response_DataWriter_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Response_DataWriter_var _var_type;

                static Sample_AutonomyModeChange_Response_DataWriter_ptr _duplicate (Sample_AutonomyModeChange_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_AutonomyModeChange_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_AutonomyModeChange_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_AutonomyModeChange_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_AutonomyModeChange_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutonomyModeChange_Response_& instance_data) = 0;

            protected:
                Sample_AutonomyModeChange_Response_DataWriter () {};
                ~Sample_AutonomyModeChange_Response_DataWriter () {};
            private:
                Sample_AutonomyModeChange_Response_DataWriter (const Sample_AutonomyModeChange_Response_DataWriter &);
                Sample_AutonomyModeChange_Response_DataWriter & operator = (const Sample_AutonomyModeChange_Response_DataWriter &);
            };

            class  Sample_AutonomyModeChange_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_AutonomyModeChange_Response_DataReader_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Response_DataReader_var _var_type;

                static Sample_AutonomyModeChange_Response_DataReader_ptr _duplicate (Sample_AutonomyModeChange_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutonomyModeChange_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutonomyModeChange_Response_& instance) = 0;

            protected:
                Sample_AutonomyModeChange_Response_DataReader () {};
                ~Sample_AutonomyModeChange_Response_DataReader () {};
            private:
                Sample_AutonomyModeChange_Response_DataReader (const Sample_AutonomyModeChange_Response_DataReader &);
                Sample_AutonomyModeChange_Response_DataReader & operator = (const Sample_AutonomyModeChange_Response_DataReader &);
            };

            class  Sample_AutonomyModeChange_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_AutonomyModeChange_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_AutonomyModeChange_Response_DataReaderView_var _var_type;

                static Sample_AutonomyModeChange_Response_DataReaderView_ptr _duplicate (Sample_AutonomyModeChange_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_AutonomyModeChange_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_AutonomyModeChange_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_AutonomyModeChange_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_AutonomyModeChange_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_AutonomyModeChange_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_AutonomyModeChange_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_AutonomyModeChange_Response_& instance) = 0;

            protected:
                Sample_AutonomyModeChange_Response_DataReaderView () {};
                ~Sample_AutonomyModeChange_Response_DataReaderView () {};
            private:
                Sample_AutonomyModeChange_Response_DataReaderView (const Sample_AutonomyModeChange_Response_DataReaderView &);
                Sample_AutonomyModeChange_Response_DataReaderView & operator = (const Sample_AutonomyModeChange_Response_DataReaderView &);
            };
        }

    }

}

#endif
