#ifndef _H_B49577B942478CD26C3A1020628465E2_HADMapService_DCPS_H_
#define _H_B49577B942478CD26C3A1020628465E2_HADMapService_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HADMapService_.h"


namespace autoware_auto_msgs
{
    namespace srv
    {
        namespace dds_
        {
            class HADMapService_Request_TypeSupportInterface;

            typedef HADMapService_Request_TypeSupportInterface * HADMapService_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Request_TypeSupportInterface> HADMapService_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HADMapService_Request_TypeSupportInterface> HADMapService_Request_TypeSupportInterface_out;


            class HADMapService_Request_DataWriter;

            typedef HADMapService_Request_DataWriter * HADMapService_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Request_DataWriter> HADMapService_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < HADMapService_Request_DataWriter> HADMapService_Request_DataWriter_out;


            class HADMapService_Request_DataReader;

            typedef HADMapService_Request_DataReader * HADMapService_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Request_DataReader> HADMapService_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < HADMapService_Request_DataReader> HADMapService_Request_DataReader_out;


            class HADMapService_Request_DataReaderView;

            typedef HADMapService_Request_DataReaderView * HADMapService_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Request_DataReaderView> HADMapService_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HADMapService_Request_DataReaderView> HADMapService_Request_DataReaderView_out;

            struct HADMapService_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HADMapService_Request_, struct HADMapService_Request_Seq_uniq_> HADMapService_Request_Seq;
            typedef DDS_DCPSSequence_var < HADMapService_Request_Seq> HADMapService_Request_Seq_var;
            typedef DDS_DCPSSequence_out < HADMapService_Request_Seq> HADMapService_Request_Seq_out;

            class  HADMapService_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HADMapService_Request_TypeSupportInterface_ptr _ptr_type;
                typedef HADMapService_Request_TypeSupportInterface_var _var_type;

                static HADMapService_Request_TypeSupportInterface_ptr _duplicate (HADMapService_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HADMapService_Request_TypeSupportInterface () {};
                ~HADMapService_Request_TypeSupportInterface () {};
            private:
                HADMapService_Request_TypeSupportInterface (const HADMapService_Request_TypeSupportInterface &);
                HADMapService_Request_TypeSupportInterface & operator = (const HADMapService_Request_TypeSupportInterface &);
            };

            class  HADMapService_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HADMapService_Request_DataWriter_ptr _ptr_type;
                typedef HADMapService_Request_DataWriter_var _var_type;

                static HADMapService_Request_DataWriter_ptr _duplicate (HADMapService_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HADMapService_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HADMapService_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HADMapService_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapService_Request_& instance_data) = 0;

            protected:
                HADMapService_Request_DataWriter () {};
                ~HADMapService_Request_DataWriter () {};
            private:
                HADMapService_Request_DataWriter (const HADMapService_Request_DataWriter &);
                HADMapService_Request_DataWriter & operator = (const HADMapService_Request_DataWriter &);
            };

            class  HADMapService_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HADMapService_Request_DataReader_ptr _ptr_type;
                typedef HADMapService_Request_DataReader_var _var_type;

                static HADMapService_Request_DataReader_ptr _duplicate (HADMapService_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HADMapService_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapService_Request_& instance) = 0;

            protected:
                HADMapService_Request_DataReader () {};
                ~HADMapService_Request_DataReader () {};
            private:
                HADMapService_Request_DataReader (const HADMapService_Request_DataReader &);
                HADMapService_Request_DataReader & operator = (const HADMapService_Request_DataReader &);
            };

            class  HADMapService_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HADMapService_Request_DataReaderView_ptr _ptr_type;
                typedef HADMapService_Request_DataReaderView_var _var_type;

                static HADMapService_Request_DataReaderView_ptr _duplicate (HADMapService_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HADMapService_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapService_Request_& instance) = 0;

            protected:
                HADMapService_Request_DataReaderView () {};
                ~HADMapService_Request_DataReaderView () {};
            private:
                HADMapService_Request_DataReaderView (const HADMapService_Request_DataReaderView &);
                HADMapService_Request_DataReaderView & operator = (const HADMapService_Request_DataReaderView &);
            };
            class HADMapService_Response_TypeSupportInterface;

            typedef HADMapService_Response_TypeSupportInterface * HADMapService_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Response_TypeSupportInterface> HADMapService_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HADMapService_Response_TypeSupportInterface> HADMapService_Response_TypeSupportInterface_out;


            class HADMapService_Response_DataWriter;

            typedef HADMapService_Response_DataWriter * HADMapService_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Response_DataWriter> HADMapService_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < HADMapService_Response_DataWriter> HADMapService_Response_DataWriter_out;


            class HADMapService_Response_DataReader;

            typedef HADMapService_Response_DataReader * HADMapService_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Response_DataReader> HADMapService_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < HADMapService_Response_DataReader> HADMapService_Response_DataReader_out;


            class HADMapService_Response_DataReaderView;

            typedef HADMapService_Response_DataReaderView * HADMapService_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HADMapService_Response_DataReaderView> HADMapService_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HADMapService_Response_DataReaderView> HADMapService_Response_DataReaderView_out;

            struct HADMapService_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HADMapService_Response_, struct HADMapService_Response_Seq_uniq_> HADMapService_Response_Seq;
            typedef DDS_DCPSSequence_var < HADMapService_Response_Seq> HADMapService_Response_Seq_var;
            typedef DDS_DCPSSequence_out < HADMapService_Response_Seq> HADMapService_Response_Seq_out;

            class  HADMapService_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HADMapService_Response_TypeSupportInterface_ptr _ptr_type;
                typedef HADMapService_Response_TypeSupportInterface_var _var_type;

                static HADMapService_Response_TypeSupportInterface_ptr _duplicate (HADMapService_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HADMapService_Response_TypeSupportInterface () {};
                ~HADMapService_Response_TypeSupportInterface () {};
            private:
                HADMapService_Response_TypeSupportInterface (const HADMapService_Response_TypeSupportInterface &);
                HADMapService_Response_TypeSupportInterface & operator = (const HADMapService_Response_TypeSupportInterface &);
            };

            class  HADMapService_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HADMapService_Response_DataWriter_ptr _ptr_type;
                typedef HADMapService_Response_DataWriter_var _var_type;

                static HADMapService_Response_DataWriter_ptr _duplicate (HADMapService_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HADMapService_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HADMapService_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HADMapService_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapService_Response_& instance_data) = 0;

            protected:
                HADMapService_Response_DataWriter () {};
                ~HADMapService_Response_DataWriter () {};
            private:
                HADMapService_Response_DataWriter (const HADMapService_Response_DataWriter &);
                HADMapService_Response_DataWriter & operator = (const HADMapService_Response_DataWriter &);
            };

            class  HADMapService_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HADMapService_Response_DataReader_ptr _ptr_type;
                typedef HADMapService_Response_DataReader_var _var_type;

                static HADMapService_Response_DataReader_ptr _duplicate (HADMapService_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HADMapService_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapService_Response_& instance) = 0;

            protected:
                HADMapService_Response_DataReader () {};
                ~HADMapService_Response_DataReader () {};
            private:
                HADMapService_Response_DataReader (const HADMapService_Response_DataReader &);
                HADMapService_Response_DataReader & operator = (const HADMapService_Response_DataReader &);
            };

            class  HADMapService_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HADMapService_Response_DataReaderView_ptr _ptr_type;
                typedef HADMapService_Response_DataReaderView_var _var_type;

                static HADMapService_Response_DataReaderView_ptr _duplicate (HADMapService_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HADMapService_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HADMapService_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HADMapService_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HADMapService_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HADMapService_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HADMapService_Response_& instance) = 0;

            protected:
                HADMapService_Response_DataReaderView () {};
                ~HADMapService_Response_DataReaderView () {};
            private:
                HADMapService_Response_DataReaderView (const HADMapService_Response_DataReaderView &);
                HADMapService_Response_DataReaderView & operator = (const HADMapService_Response_DataReaderView &);
            };
            class Sample_HADMapService_Request_TypeSupportInterface;

            typedef Sample_HADMapService_Request_TypeSupportInterface * Sample_HADMapService_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Request_TypeSupportInterface> Sample_HADMapService_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Request_TypeSupportInterface> Sample_HADMapService_Request_TypeSupportInterface_out;


            class Sample_HADMapService_Request_DataWriter;

            typedef Sample_HADMapService_Request_DataWriter * Sample_HADMapService_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Request_DataWriter> Sample_HADMapService_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Request_DataWriter> Sample_HADMapService_Request_DataWriter_out;


            class Sample_HADMapService_Request_DataReader;

            typedef Sample_HADMapService_Request_DataReader * Sample_HADMapService_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Request_DataReader> Sample_HADMapService_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Request_DataReader> Sample_HADMapService_Request_DataReader_out;


            class Sample_HADMapService_Request_DataReaderView;

            typedef Sample_HADMapService_Request_DataReaderView * Sample_HADMapService_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Request_DataReaderView> Sample_HADMapService_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Request_DataReaderView> Sample_HADMapService_Request_DataReaderView_out;

            struct Sample_HADMapService_Request_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_HADMapService_Request_, struct Sample_HADMapService_Request_Seq_uniq_> Sample_HADMapService_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_HADMapService_Request_Seq> Sample_HADMapService_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HADMapService_Request_Seq> Sample_HADMapService_Request_Seq_out;

            class  Sample_HADMapService_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HADMapService_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HADMapService_Request_TypeSupportInterface_var _var_type;

                static Sample_HADMapService_Request_TypeSupportInterface_ptr _duplicate (Sample_HADMapService_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HADMapService_Request_TypeSupportInterface () {};
                ~Sample_HADMapService_Request_TypeSupportInterface () {};
            private:
                Sample_HADMapService_Request_TypeSupportInterface (const Sample_HADMapService_Request_TypeSupportInterface &);
                Sample_HADMapService_Request_TypeSupportInterface & operator = (const Sample_HADMapService_Request_TypeSupportInterface &);
            };

            class  Sample_HADMapService_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HADMapService_Request_DataWriter_ptr _ptr_type;
                typedef Sample_HADMapService_Request_DataWriter_var _var_type;

                static Sample_HADMapService_Request_DataWriter_ptr _duplicate (Sample_HADMapService_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HADMapService_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HADMapService_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HADMapService_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HADMapService_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HADMapService_Request_& instance_data) = 0;

            protected:
                Sample_HADMapService_Request_DataWriter () {};
                ~Sample_HADMapService_Request_DataWriter () {};
            private:
                Sample_HADMapService_Request_DataWriter (const Sample_HADMapService_Request_DataWriter &);
                Sample_HADMapService_Request_DataWriter & operator = (const Sample_HADMapService_Request_DataWriter &);
            };

            class  Sample_HADMapService_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HADMapService_Request_DataReader_ptr _ptr_type;
                typedef Sample_HADMapService_Request_DataReader_var _var_type;

                static Sample_HADMapService_Request_DataReader_ptr _duplicate (Sample_HADMapService_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HADMapService_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HADMapService_Request_& instance) = 0;

            protected:
                Sample_HADMapService_Request_DataReader () {};
                ~Sample_HADMapService_Request_DataReader () {};
            private:
                Sample_HADMapService_Request_DataReader (const Sample_HADMapService_Request_DataReader &);
                Sample_HADMapService_Request_DataReader & operator = (const Sample_HADMapService_Request_DataReader &);
            };

            class  Sample_HADMapService_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HADMapService_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_HADMapService_Request_DataReaderView_var _var_type;

                static Sample_HADMapService_Request_DataReaderView_ptr _duplicate (Sample_HADMapService_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HADMapService_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HADMapService_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HADMapService_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HADMapService_Request_& instance) = 0;

            protected:
                Sample_HADMapService_Request_DataReaderView () {};
                ~Sample_HADMapService_Request_DataReaderView () {};
            private:
                Sample_HADMapService_Request_DataReaderView (const Sample_HADMapService_Request_DataReaderView &);
                Sample_HADMapService_Request_DataReaderView & operator = (const Sample_HADMapService_Request_DataReaderView &);
            };
            class Sample_HADMapService_Response_TypeSupportInterface;

            typedef Sample_HADMapService_Response_TypeSupportInterface * Sample_HADMapService_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Response_TypeSupportInterface> Sample_HADMapService_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Response_TypeSupportInterface> Sample_HADMapService_Response_TypeSupportInterface_out;


            class Sample_HADMapService_Response_DataWriter;

            typedef Sample_HADMapService_Response_DataWriter * Sample_HADMapService_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Response_DataWriter> Sample_HADMapService_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Response_DataWriter> Sample_HADMapService_Response_DataWriter_out;


            class Sample_HADMapService_Response_DataReader;

            typedef Sample_HADMapService_Response_DataReader * Sample_HADMapService_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Response_DataReader> Sample_HADMapService_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Response_DataReader> Sample_HADMapService_Response_DataReader_out;


            class Sample_HADMapService_Response_DataReaderView;

            typedef Sample_HADMapService_Response_DataReaderView * Sample_HADMapService_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_HADMapService_Response_DataReaderView> Sample_HADMapService_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_HADMapService_Response_DataReaderView> Sample_HADMapService_Response_DataReaderView_out;

            struct Sample_HADMapService_Response_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Sample_HADMapService_Response_, struct Sample_HADMapService_Response_Seq_uniq_> Sample_HADMapService_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_HADMapService_Response_Seq> Sample_HADMapService_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_HADMapService_Response_Seq> Sample_HADMapService_Response_Seq_out;

            class  Sample_HADMapService_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_HADMapService_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_HADMapService_Response_TypeSupportInterface_var _var_type;

                static Sample_HADMapService_Response_TypeSupportInterface_ptr _duplicate (Sample_HADMapService_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_HADMapService_Response_TypeSupportInterface () {};
                ~Sample_HADMapService_Response_TypeSupportInterface () {};
            private:
                Sample_HADMapService_Response_TypeSupportInterface (const Sample_HADMapService_Response_TypeSupportInterface &);
                Sample_HADMapService_Response_TypeSupportInterface & operator = (const Sample_HADMapService_Response_TypeSupportInterface &);
            };

            class  Sample_HADMapService_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_HADMapService_Response_DataWriter_ptr _ptr_type;
                typedef Sample_HADMapService_Response_DataWriter_var _var_type;

                static Sample_HADMapService_Response_DataWriter_ptr _duplicate (Sample_HADMapService_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_HADMapService_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_HADMapService_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_HADMapService_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_HADMapService_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HADMapService_Response_& instance_data) = 0;

            protected:
                Sample_HADMapService_Response_DataWriter () {};
                ~Sample_HADMapService_Response_DataWriter () {};
            private:
                Sample_HADMapService_Response_DataWriter (const Sample_HADMapService_Response_DataWriter &);
                Sample_HADMapService_Response_DataWriter & operator = (const Sample_HADMapService_Response_DataWriter &);
            };

            class  Sample_HADMapService_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_HADMapService_Response_DataReader_ptr _ptr_type;
                typedef Sample_HADMapService_Response_DataReader_var _var_type;

                static Sample_HADMapService_Response_DataReader_ptr _duplicate (Sample_HADMapService_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HADMapService_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HADMapService_Response_& instance) = 0;

            protected:
                Sample_HADMapService_Response_DataReader () {};
                ~Sample_HADMapService_Response_DataReader () {};
            private:
                Sample_HADMapService_Response_DataReader (const Sample_HADMapService_Response_DataReader &);
                Sample_HADMapService_Response_DataReader & operator = (const Sample_HADMapService_Response_DataReader &);
            };

            class  Sample_HADMapService_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_HADMapService_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_HADMapService_Response_DataReaderView_var _var_type;

                static Sample_HADMapService_Response_DataReaderView_ptr _duplicate (Sample_HADMapService_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_HADMapService_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_HADMapService_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_HADMapService_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_HADMapService_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_HADMapService_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_HADMapService_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_HADMapService_Response_& instance) = 0;

            protected:
                Sample_HADMapService_Response_DataReaderView () {};
                ~Sample_HADMapService_Response_DataReaderView () {};
            private:
                Sample_HADMapService_Response_DataReaderView (const Sample_HADMapService_Response_DataReaderView &);
                Sample_HADMapService_Response_DataReaderView & operator = (const Sample_HADMapService_Response_DataReaderView &);
            };
        }

    }

}

#endif
